"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var pinyin_service_1 = require("../pinyin.service");
var AutoCompleteComponent = (function () {
    function AutoCompleteComponent(resolver, router, pinyinService) {
        this.resolver = resolver;
        this.router = router;
        this.pinyinService = pinyinService;
        this.textChangeEvent = new core_1.EventEmitter();
        this.show_source = [];
    }
    AutoCompleteComponent.prototype.ngOnInit = function () {
    };
    AutoCompleteComponent.prototype.ngOnChanges = function (changes) {
    };
    AutoCompleteComponent.prototype.blur = function () {
        var _this = this;
        setTimeout(function () {
            _this.showContainer = false;
        }, 200);
    };
    AutoCompleteComponent.prototype.focus = function () {
        this.changeText();
    };
    AutoCompleteComponent.prototype.press = function (event) {
        if (event.key == 'Tab') {
            event.preventDefault();
            for (var i = 0; i < this.show_source.length; i++) {
                if (this.show_source[i].show) {
                    this.show_source[i].show = false;
                    if (i == this.show_source.length - 1) {
                        this.show_source[0].show = true;
                    }
                    else {
                        this.show_source[i + 1].show = true;
                    }
                    break;
                }
            }
        }
        if (event.key == 'Enter') {
            for (var _a = 0, _b = this.show_source; _a < _b.length; _a++) {
                var _c = _b[_a];
                if (_c.show) {
                    this.text = _c.title;
                    this.textChangeEvent.emit(_c);
                }
            }
            this.showContainer = false;
        }
    };
    AutoCompleteComponent.prototype.changeText = function () {
        var _this = this;
        if (this.text == null) {
            this.text = '';
        }
        this.show_source = [];
        var tempSource = this.source.filter(function (item) {
            var _i = item;
            if (item == null) {
                _i = '';
            }
            return _i.indexOf(_this.text) >= 0 || _this.pinyinService.toPinyin(_i).indexOf(_this.text) >= 0;
        });
        for (var i = 0; i < tempSource.length; i++) {
            var _show = i == 0;
            this.show_source.push({
                title: tempSource[i] == null ? '' : tempSource[i],
                show: _show
            });
        }
        this.showContainer = true;
    };
    AutoCompleteComponent.prototype.selectText = function (t) {
        this.text = t.title;
        this.preText = this.text;
        this.showContainer = false;
        this.textChangeEvent.emit(t);
    };
    AutoCompleteComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dc-auto-component',
                    template: "\n    <div class=\"display-flex width-100 flex-direction-column\" [style.position]=\"'relative'\" [style.max-width]=\"width\">\n      <input type=\"text\" [(ngModel)]=\"text\" (keydown)=\"press($event)\" (blur)=\"blur()\" (focus)=\"focus()\" (ngModelChange)=\"changeText()\">\n      <div class=\"complete-container width-100 flex-direction-column\" *ngIf=\"showContainer\">\n        <div *ngFor=\"let c of show_source\" class=\"source-title\" [class.selected]=\"preText==c.title\"\n             [ngClass]=\"{active:c.show}\" (click)=\"selectText(c)\" [title]=\"c.title\">\n          {{c.title}}\n        </div>\n      </div>\n    </div>\n  ",
                    styles: ["\n    .title.active {\n      color: red\n    }\n\n    input[type=text] {\n      border: solid 1px #ccc;\n      height: 30px;\n      line-height: 18px;\n    }\n\n    input[type=text]:hover, input[type=text]:focus {\n      border-color: #0081cc;\n    }\n\n    .title {\n      cursor: pointer;\n    }\n\n    .complete-container {\n      position: absolute;\n      top: 28px;\n      border: solid 1px #ccc;\n      background-color: #ffffff;\n      box-shadow: 0px 0px 5px 2px rgba(0, 0, 0, .2);\n      z-index: 1100;\n      max-height: 200px;\n      overflow: auto;\n    }\n\n    .source-title {\n      max-width: 100%;\n      height: 30px;\n      overflow: hidden;\n      text-overflow: ellipsis;\n      white-space: nowrap;\n      cursor: pointer;\n    }\n\n    .source-title:hover {\n      background-color: #edf0f5;\n    }\n\n    .selected {\n      background-color: #0081cc;\n      color: #ffffff;\n    }\n\n    .source-title.active {\n      color: rebeccapurple;\n    }\n  "]
                },] },
    ];
    /** @nocollapse */
    AutoCompleteComponent.ctorParameters = function () { return [
        { type: core_1.ComponentFactoryResolver, },
        { type: router_1.Router, },
        { type: pinyin_service_1.PinyinService, },
    ]; };
    AutoCompleteComponent.propDecorators = {
        "source": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "text": [{ type: core_1.Input },],
        "textChangeEvent": [{ type: core_1.Output },],
    };
    return AutoCompleteComponent;
}());
exports.AutoCompleteComponent = AutoCompleteComponent;
//# sourceMappingURL=auto.component.component.js.map